.486
.model flat, stdcall
option casemap: none

PNGBTN	equ	1
; API functions
; ************************************
include	AeroVistaButtons.inc
include lib\bmpbutn.asm
include lib\shadow_Flat.asm
.const
; Resource ids
; ************************************
IDD_DLG1  	        equ 101
IDI_ICON            equ 200
IDI_EXIT	        equ 300
IDI_MINIMIZE        equ 400
IDI_MAXIMIZE        equ 500
IDC_FRAME           equ 800
TRANSPARENT_VALUE	equ 230
NC_HEIGHT           equ 18
SIZEOFTITLEBAR	    equ 30   ; Height of title bar (in pixels)
WIDTHSYSBUTTON	    equ 210  ; Width of the buttons Systems
TITLEFONT			equ 'MS Sans Serif'
IDI_SHADOWBMP       equ 300
; Required data
; ************************************
.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hWND		dd	?
hExit		dd	?
hMin        dd	?
hMax        dd	?
rct     RECT   <?>
rect    RECT	<>
hIMG		dd	?
hBrush		dd	?
hFontTitle	dd	?
.data
szTitle     db 'Areo-Windows 7 skin', 0
szFontName  db 'Lucida Console',0
.code

start:


invoke GetModuleHandle, NULL
mov hInstance, eax

invoke LoadIcon, eax, IDI_ICON 
mov hIcon, eax
invoke	InitShadow, hInstance, IDI_SHADOWBMP ; istead of IDI_SHADOWBMP you can just have the sresourse shadow #
invoke InitCommonControls
invoke DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, SW_SHOWDEFAULT
invoke ExitProcess, 0


; Dialog procedure
; ************************************
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL ps:PAINTSTRUCT
LOCAL hdc:HDC
 invoke	ProcessShadowProc, hWnd, uMsg
 
Mov	eax, uMsg
.if eax == WM_INITDIALOG
;Create font
mov hFontTitle,FUNC(CreateFont,16, 0, 0, 0, FW_BOLD, 0, 0, 0, 0, 0, 0, 0, 0, SADD(TITLEFONT))  
; make dialog transparent
invoke TranspWindow,hWnd,TRANSPARENT_VALUE
invoke LoadPng,800,addr sizeFrame
mov hIMG,eax
invoke CreatePatternBrush,hIMG
mov hBrush,eax
invoke ImageButton,hWnd,246,2,703,701,702,IDI_EXIT		;custom image button (JPG,BMP,PNG) Left,Up,DownID,UpID,OverID
mov hExit,eax
invoke ImageButton,hWnd,195,2,503,501,502,IDI_MINIMIZE	;custom image button (JPG,BMP,PNG) Left,Up,DownID,UpID,OverID
mov hMin,eax
; Using the same up position for the button so it looks disabled whem cursor over it
invoke ImageButton,hWnd,220,2,603,601,602,IDI_MAXIMIZE	;custom image button (JPG,BMP,PNG) Left,Up,DownID,UpID,OverID
mov hMax,eax

invoke GetWindowLong,hWnd,GWL_EXSTYLE 
or eax,WS_EX_LAYERED 

invoke ShowWindow,hWnd,SW_SHOW

; Create rounded corners
invoke GetClientRect,hWnd,offset rct
invoke CreateRoundRectRgn,0,0,rct.right,rct.bottom,13,13
invoke SetWindowRgn,hWnd,eax,TRUE

.elseif uMsg == WM_CTLCOLORDLG
mov eax,hBrush
ret
.elseif uMsg == WM_PAINT
invoke BeginPaint,hWnd,addr ps
mov edi,eax
lea ebx,rect
assume ebx:ptr RECT
invoke SelectObject, ps.hdc, hFontTitle
; Define the rectangle in which to write the text	
push rect.bottom
push rect.right
sub rect.right,-WIDTHSYSBUTTON ; To center the buttons in the light systems
mov rect.bottom, SIZEOFTITLEBAR ; Set the title bar is the bottom of the rectangle
invoke  SetTextColor,  ps.hdc,00FFFFFFh
invoke  SetBkMode,  ps.hdc, TRANSPARENT
INVOKE DrawText,ps.hdc,addr szTitle,-1,addr rect,DT_CENTER or DT_VCENTER or DT_SINGLELINE or DT_NOCLIP	; Write Our Title
pop rect.right
pop rect.bottom
invoke DrawIconEx, ps.hdc, 5, 5, hIcon, NC_HEIGHT-2, NC_HEIGHT-2, 0, NULL, DI_NORMAL ; Draw our Icon
invoke GetClientRect,hWnd,ebx
invoke CreateSolidBrush,0
invoke FrameRect,edi,ebx,eax
invoke EndPaint,hWnd,addr ps

.elseif eax == WM_LBUTTONDOWN
invoke SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0

.elseif  uMsg == WM_COMMAND


.if  wParam ==IDI_EXIT ; Exit Button 
invoke SendMessage,hWnd,WM_CLOSE,0,0
.endif
.if  wParam ==IDI_MINIMIZE ; Minimize Window Button   
invoke ShowWindow,hWnd,SW_MINIMIZE
.endif

.elseif  uMsg == WM_CLOSE 
invoke EndDialog, hWnd, 0
.endif
 
xor eax,eax
ret
DialogProc endp
; Load Png procedure
; ************************************
LoadPng proc ID:DWORD,pSize:DWORD
local pngInfo:PNGINFO

invoke PNG_Init, addr pngInfo
invoke PNG_LoadResource, addr pngInfo, hInstance, ID
.if !eax
xor eax, eax
jmp @cleanup
.endif
invoke PNG_Decode, addr pngInfo
.if !eax
xor eax, eax
jmp @cleanup
.endif
invoke PNG_CreateBitmap, addr pngInfo, hWND, PNG_OUTF_AUTO, FALSE
.if	!eax
xor eax, eax
jmp @cleanup
.endif
mov edi,pSize
.if edi!=0
lea esi,pngInfo
movsd
movsd
.endif

@cleanup:
push eax	
invoke PNG_Cleanup, addr pngInfo

pop eax
ret

LoadPng endp
; TranspWindow procedure
; ************************************
TranspWindow proc _dialoghandle:dword,_value:dword

pushad
invoke GetModuleHandle,chr$("user32.dll")
invoke GetProcAddress,eax,chr$("SetLayeredWindowAttributes")
.if eax!=0

mov edi,eax
invoke GetWindowLong,_dialoghandle,GWL_EXSTYLE	;get EXSTYLE

.if _value==255
xor eax,WS_EX_LAYERED	;remove WS_EX_LAYERED
.else
or eax,WS_EX_LAYERED	;eax = oldstlye + new style(WS_EX_LAYERED)
.endif
invoke SetWindowLong,_dialoghandle,GWL_EXSTYLE,eax

.if _value<255
push LWA_ALPHA
push _value		    ;set level of transparency
push 0			    ;transparent color
push _dialoghandle	;window handle
call edi			;call SetLayeredWindowAttributes
.endif	
.endif

popad
ret
TranspWindow endp
end start